/// <reference types="react" />
import { ObjectClean } from 'typelevel-ts';
import { PartialKeys } from '@devexperts/utils/lib/object/object';
import { ComponentClass } from 'react';
export declare const LOADING_INDICATOR: symbol;
export declare type TFullLoadingIndicatorProps = {
    theme: {
        container?: string;
    };
};
export declare type TLoadingIndicatorProps = ObjectClean<PartialKeys<TFullLoadingIndicatorProps, 'theme'>>;
export declare const LoadingIndicator: ComponentClass<TLoadingIndicatorProps>;
