'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.LoadingIndicator = exports.LOADING_INDICATOR = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _pure = require('../../utils/pure');

var _withTheme = require('../../utils/withTheme');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LOADING_INDICATOR = exports.LOADING_INDICATOR = Symbol('LoadingIndicator');
var RawLoadingIndicator = function (_React$Component) {
    _inherits(RawLoadingIndicator, _React$Component);

    function RawLoadingIndicator() {
        _classCallCheck(this, RawLoadingIndicator);

        return _possibleConstructorReturn(this, (RawLoadingIndicator.__proto__ || Object.getPrototypeOf(RawLoadingIndicator)).apply(this, arguments));
    }

    _createClass(RawLoadingIndicator, [{
        key: 'render',
        value: function render() {
            var theme = this.props.theme;

            return React.createElement("div", { className: theme.container });
        }
    }]);

    return RawLoadingIndicator;
}(React.Component);
RawLoadingIndicator = tslib_1.__decorate([_pure.PURE], RawLoadingIndicator);
var LoadingIndicator = exports.LoadingIndicator = (0, _withTheme.withTheme)(LOADING_INDICATOR)(RawLoadingIndicator);