'use strict';

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var tslib_1 = _interopRequireWildcard(_tslib);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Demo = require('../demo/Demo');

var _Demo2 = _interopRequireDefault(_Demo);

var _Button = require('../Button/Button');

var _Popover = require('./Popover');

var _Selectbox = require('../Selectbox/Selectbox');

var _Menu = require('../Menu/Menu');

var _pure = require('../../utils/pure');

var _storybook = require('@devexperts/tools/lib/utils/storybook');

var _Control = require('../Control/Control');

var _PopoverPage = require('./Popover.page.styl');

var _PopoverPage2 = _interopRequireDefault(_PopoverPage);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var buttonTheme = {
    container: _PopoverPage2.default.toggleButton
};
var HeavyContent = function (_React$Component) {
    _inherits(HeavyContent, _React$Component);

    function HeavyContent() {
        _classCallCheck(this, HeavyContent);

        return _possibleConstructorReturn(this, (HeavyContent.__proto__ || Object.getPrototypeOf(HeavyContent)).apply(this, arguments));
    }

    _createClass(HeavyContent, [{
        key: 'render',
        value: function render() {
            return _react2.default.createElement("div", null, _react2.default.createElement("h2", null, "Tethered Content"), _react2.default.createElement("p", null, "A paragraph to accompany the title."), _react2.default.createElement("p", null, "A paragraph to accompany the title."), _react2.default.createElement("p", null, "A paragraph to accompany the title."), _react2.default.createElement("p", null, "A paragraph to accompany the title."), _react2.default.createElement("p", null, "A paragraph to accompany the title."), this.props.isLong && _react2.default.createElement("div", null, _react2.default.createElement("p", null, "A paragraph to accompany the title."), _react2.default.createElement("p", null, "A paragraph to accompany the title."), _react2.default.createElement("p", null, "A paragraph to accompany the title."), _react2.default.createElement("p", null, "A paragraph to accompany the title.")));
        }
    }]);

    return HeavyContent;
}(_react2.default.Component);
HeavyContent = tslib_1.__decorate([_pure.PURE], HeavyContent);
var Stateful = (0, _Control.stateful)()(_Selectbox.Selectbox);
var PopoverPage = function (_React$Component2) {
    _inherits(PopoverPage, _React$Component2);

    function PopoverPage() {
        _classCallCheck(this, PopoverPage);

        var _this2 = _possibleConstructorReturn(this, (PopoverPage.__proto__ || Object.getPrototypeOf(PopoverPage)).apply(this, arguments));

        _this2.state = {
            placement: _Popover.PopoverPlacement.Bottom,
            align: _Popover.PopoverAlign.Left,
            isOpened: false,
            isLongText: false,
            closeOnClickAway: false
        };
        _this2.onPlacementSelect = function (placement) {
            var placementWasVertical = [_Popover.PopoverPlacement.Top, _Popover.PopoverPlacement.Bottom].includes(_this2.state.placement);
            var placementWillBeVertical = [_Popover.PopoverPlacement.Top, _Popover.PopoverPlacement.Bottom].includes(placement);
            if (placementWasVertical && !placementWillBeVertical) {
                //placement orientation changed from vertical to horizontal
                //choose default vertical align
                _this2.setState({
                    align: _Popover.PopoverAlign.Top
                });
            } else if (!placementWasVertical && placementWillBeVertical) {
                //placement orientation changed from horizontal to vertical
                //choose default horizontal align
                _this2.setState({
                    align: _Popover.PopoverAlign.Left
                });
            }
            //finally set placement
            _this2.setState({
                placement: placement
            });
        };
        _this2.onAlignSelect = function (align) {
            _this2.setState({
                align: align
            });
        };
        _this2.onToggleClick = function () {
            _this2.setState({
                isOpened: !_this2.state.isOpened
            });
        };
        _this2.onPopoverRequestClose = function () {
            _this2.setState({
                isOpened: false
            });
        };
        _this2.onCloseOnClickAwayChange = function () {
            _this2.setState({
                closeOnClickAway: !_this2.state.closeOnClickAway
            });
        };
        return _this2;
    }

    _createClass(PopoverPage, [{
        key: 'render',
        value: function render() {
            var _this3 = this;

            var _state = this.state,
                placement = _state.placement,
                align = _state.align,
                isOpened = _state.isOpened,
                closeOnClickAway = _state.closeOnClickAway;

            return _react2.default.createElement(_Demo2.default, null, _react2.default.createElement("div", { className: _PopoverPage2.default.container }, _react2.default.createElement("div", null, _react2.default.createElement("label", { className: _PopoverPage2.default.label }, "Placement"), _react2.default.createElement(Stateful, { defaultValue: _Popover.PopoverPlacement.Bottom, onValueChange: this.onPlacementSelect }, _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverPlacement.Top }, "Top"), _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverPlacement.Bottom }, "Bottom"), _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverPlacement.Left }, "Left"), _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverPlacement.Right }, "Right")), _react2.default.createElement("label", { className: _PopoverPage2.default.label }, "Align"), (placement === _Popover.PopoverPlacement.Top || placement === _Popover.PopoverPlacement.Bottom) && _react2.default.createElement(Stateful, { defaultValue: _Popover.PopoverAlign.Left, onValueChange: this.onAlignSelect }, _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverAlign.Left }, "Left"), _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverAlign.Center }, "Center"), _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverAlign.Right }, "Right")), (placement === _Popover.PopoverPlacement.Left || placement === _Popover.PopoverPlacement.Right) && _react2.default.createElement(Stateful, { defaultValue: _Popover.PopoverAlign.Top, onValueChange: this.onAlignSelect }, _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverAlign.Top }, "Top"), _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverAlign.Middle }, "Middle"), _react2.default.createElement(_Menu.MenuItem, { value: _Popover.PopoverAlign.Bottom }, "Bottom")), _react2.default.createElement("label", { className: _PopoverPage2.default.label }, "Close on clickaway ", _react2.default.createElement("input", { type: "checkbox", value: closeOnClickAway.toString(), onChange: this.onCloseOnClickAwayChange }))), _react2.default.createElement(_Button.Button, { isPrimary: true, onClick: this.onToggleClick, ref: function ref(el) {
                    return _this3._anchor = el;
                }, theme: buttonTheme }, isOpened ? 'Hide' : 'Open', _react2.default.createElement(_Popover.Popover, { placement: placement, isOpened: isOpened, onRequestClose: this.onPopoverRequestClose, closeOnClickAway: closeOnClickAway, hasArrow: true, align: align, anchor: this._anchor }, _react2.default.createElement(HeavyContent, null)))));
        }
    }]);

    return PopoverPage;
}(_react2.default.Component);
PopoverPage = tslib_1.__decorate([_pure.PURE], PopoverPage);
(0, _storybook.storiesOf)('Popover', module).add('default', function () {
    return _react2.default.createElement(PopoverPage, null);
});