'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Demo = exports.DemoComponent = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _withTheme = require('../../utils/withTheme');

var _DefaultTheme = require('../DefaultTheme/DefaultTheme');

var _Demo = require('./Demo.styl');

var _Demo2 = _interopRequireDefault(_Demo);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DEMO = Symbol();

var RawDemoComponent = function (_React$Component) {
    _inherits(RawDemoComponent, _React$Component);

    function RawDemoComponent() {
        _classCallCheck(this, RawDemoComponent);

        return _possibleConstructorReturn(this, (RawDemoComponent.__proto__ || Object.getPrototypeOf(RawDemoComponent)).apply(this, arguments));
    }

    _createClass(RawDemoComponent, [{
        key: 'render',
        value: function render() {
            var _props = this.props,
                children = _props.children,
                theme = _props.theme;

            return _react2.default.createElement("section", { className: theme.container }, children);
        }
    }]);

    return RawDemoComponent;
}(_react2.default.Component);

var DemoComponent = exports.DemoComponent = (0, _withTheme.withTheme)(DEMO, _Demo2.default)(RawDemoComponent);
var Demo = function Demo(props) {
    return _react2.default.createElement(_DefaultTheme.DefaultTheme, null, _react2.default.createElement(DemoComponent, { theme: props.theme }, props.children));
};
exports.default = Demo;
exports.Demo = Demo;