'use strict';

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _storybook = require('@devexperts/tools/lib/utils/storybook');

var _Demo = require('../demo/Demo');

var _Input = require('./Input');

var _InputPage = require('./Input.page.styl');

var css = _interopRequireWildcard(_InputPage);

var _InputDemo = require('./Input.demo.styl');

var demoCss = _interopRequireWildcard(_InputDemo);

var _Control = require('../Control/Control');

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var darkDemoTheme = {
    container: css.container
};
var Stateful = (0, _Control.stateful)()(_Input.Input);
(0, _storybook.storiesOf)('Input', module).add('Default', function () {
    return React.createElement(_Demo.Demo, { theme: darkDemoTheme }, React.createElement(Stateful, { defaultValue: "<Input/>", onValueChange: (0, _storybook.action)('change') }), React.createElement(_Input.Input, { type: "hidden", tabIndex: 0, value: "123", onValueChange: undefined }, React.createElement("div", { className: demoCss.input }, "div")));
}).add('Readonly', function () {
    return React.createElement(_Demo.Demo, { theme: darkDemoTheme }, React.createElement(Stateful, { defaultValue: "<Input/>", isReadOnly: true }));
}).add('Disabled', function () {
    return React.createElement(_Demo.Demo, { theme: darkDemoTheme }, React.createElement(Stateful, { defaultValue: "Test Value", isDisabled: true }));
}).add('Invalid', function () {
    return React.createElement(_Demo.Demo, { theme: darkDemoTheme }, React.createElement(Stateful, { defaultValue: "Error", error: "Error" }));
});